;TIP1055.LSP:  LDRM.LSP     Leader with Bubbles     (C)1994,  Curtis R. Edwards

(defun C:LDRM ()
   (graphscr)
   (setvar "cmdecho" 0)
   (setvar "orthomode" 0)
   (setvar "regenmode" 0)
   (setvar "blipmode" 0)
   (setvar "snapmode" 0)
   (setvar "coords" 2)
   (setq PTLST NIL
      OP NIL
      P1 NIL
      SCL (getvar "dimscale")
      LA1(getvar "clayer")
      W1(* SCL 0.06)
      TXT T
   )
   (setvar "filletrad" (* SCL 0.099))
   (setq LIM(car(getvar "limmax")))
   (if (<= LIM (* SCL 17.0))
      (progn
         (setq THGT(* SCL 0.125))
         (command "style" "125" "simplex" THGT "0.8" "0.0" "n" "n" "n")
      )
      (progn
         (setq THGT(* SCL 0.15))
         (command "style" "150" "simplex" THGT "0.8" "0.0" "n" "n" "n")
      )
   )
   (cond
      ((= nil (tblsearch "layer" "1-dim"))
         (command "layer" "n" "1-dim" "c" "1" "1-dim" "")
      )
   )
   (cond
      ((= nil (tblsearch "layer" "2-txt"))
         (command "layer" "n" "2-txt" "c" "2" "2-txt" "")
      )
   )
   (cond
      ((= nil (tblsearch "layer" "3-obj"))
         (command "layer" "n" "3-obj" "c" "3" "3-obj" "")
      )
   )
   ;LABEL
   (grtext -1 "SNAP IS OFF!")
   (prompt "Leader: ")
   (initget 1)
   (setq TP(getpoint "\nPick first point: ")
      P1 TP       
   )
   (setvar "snapmode" 1)
   (grtext -1 "SNAP IS ON!")
   (while (/= TP nil)
      (setq OP TP
         PTLST(append PTLST(LIST TP))
         TP(getpoint TP "\nPick next point or ENTER when done: ")
      )
      (cond
         ((/= TP nil)
            (grdraw OP TP 1)
         )
      )
   )
   (setq ANG1(angle P1 (cadr PTLST))
      P2(polar P1 ANG1 (* SCL 0.188))
      PTLst(cdr PTLST)
      PX(last PTLST)
   )
   (cond
      ((<= (car P1) (car PX))
         (progn
            (setq DIR(strcase(getstring 
               "\nLeader leg: Direction - (L)eft or <(R)ight>: "))
            )
            (if (/= DIR "L")
               (setq DIR 1)
               (setq DIR -1)
            )
         )
      )
      ((> (car P1) (car PX))
         (progn
            (setq DIR(strcase(getstring 
            "\nLeader leg: Direction - <(L)eft> or (R)ight: ")))
            (if (/= DIR "R")
               (setq DIR -1)
               (setq DIR 1)
            )
         )
      )
   )
   (setq TP(polar px 0 (* SCL DIR 0.2))
      PTLST(append PTLST(list TP))
   )
   (setq DOT(strcase(getstring "\n(D)ot or <(A)rrow>: ")))
   (if (/= DOT "D")
      (setq DOT "A")
   )
   (cond
      ((= DOT "A")
         (command "layer" "s" "1-dim" ""
            "pline" P1 "w" 0 W1 P2 "w" 0 0 (foreach TP PTLST(command TP)) 
         )
      )
      ((= dot "D")
         (setq P1(POLAR P1 0 (* SCL 0.03))
            XP(car PTLST)
         )
         (grdraw P1 XP 0)
         (command "layer" "s" "1-dim" ""
            "pline" P1 "w" w1 w1 "a" "ce" D1 "a" 359.99 "l" "w" 0 0 
            D1 (foreach TP PTLST(command TP))
         )
      )
   )
   ;BUBBLE
   (command "layer" "s" "3-obj" "")
   (initget 5)
   (setq BUB(Getint "\nNumber of bubbles: ")
      BUB1 BUB
      BUB2 BUB
      D1(* SCL 0.375)
      INC(* D1 -1)
      CEN(list(+(* SCL 0.1875 DIR)(car TP))(cadr TP))
      CEN1 CEN
      TP1(list(+(* SCL 0.3 DIR)(car CEN))(-(cadr CEN)(/ THGT 2)))
   )
   (cond
      ((/= BUB1 0)
         (iF (/= BUB1 1)
            (progn
               (coMMAND "CIRCLE" CEN "D" D1
                  "array" "l" "" "r" BUB "" INC
               )
            )
            (command "circle" CEN "d" D1)
         )
         ;ITEM NUMBERS
         (command "layer" "s" "2-txt" "")
         (while (/= BUB 0)
            (setq TP2(list(-(car CEN)(* SCL 0.075))(-(cadr CEN)(/ THGT 2)))
               TP3(polar TP2 0 (* SCL 0.15))
               TP4(polar TP3 (/ PI 2) THGT)
               TP5(polar TP2 (/ PI 2) THGT)
            )
            (grdraw TP2 TP3 2 -1)
            (grdraw TP3 TP4 2 -1)
            (grdraw TP4 TP5 2 -1)
            (grdraw TP5 TP2 2 -1)
            (initget 1)
            (setq ITEM(strcase(getstring "\nItem #: ")))
            (grdraw TP2 TP3 0)
            (grdraw TP3 TP4 0)
            (grdraw TP4 TP5 0)
            (grdraw TP5 TP2 0)
            (command "text" "m" CEN "" item)
            (setq CEN(list(car CEN)(+(cadr CEN)INC))
               BUB(1- BUB)
            )
         )
         ;QUANTITY
         (setq QTY nil
            OQLEN(* 0.8 THGT)
         )
         (while (and(/= BUB1 0)(/= QTY ""))
            (setq TP2(polar TP1 0 (* SCL 0.3 DIR))
               TP3(polar TP2 (/ PI 2) THGT)
               TP4(polar TP1 (/ PI 2) THGT)
               BUB1(1- BUB1)
            )
            (grdraw TP1 TP2 2 -1)
            (grdraw TP2 TP3 2 -1)
            (grdraw TP3 TP4 2 -1)
            (grdraw TP4 TP1 2 -1)
            (setq QTY(strcase(getstring T "\nQuantity: "))
               QLEN(max OQLEN (* 0.8 THGT (strlen QTY)))
               OQLEN(max QLEN (* 0.8 THGT (strlen QTY)))         
            )
            (grdraw TP1 TP2 0)
            (grdraw TP2 TP3 0)
            (grdraw TP3 TP4 0)
            (grdraw TP4 TP1 0)
            (if (/= qty "0")
               (if (= DIR -1)
                  (command "text" "r" TP1 "" QTY)
                  (command "text" TP1 "" QTY)
               )
            )
            (setq TP1(list(car TP1)(+(cadr TP1)INC)))
         )
         ;BRACKET
         (cond
            ((> BUB2 1)
               (setq BRK1(getint "\nTop bubble: "))
               (cond
                  ((/= BRK1 nil)
                     (setq BRK2(getint "\nBottom bubble: ")
                        BRKS(- BRK1 1)
                        BRKL(* INC(- BRK2 BRKS))
                        P1(List(+(car CEN1)(* DIR(max QLEN OQLEN))(* SCL DIR 0.3))
                        (-(+(cadr CEN1)(* SCL 0.1875))(* BRKS D1)));Y coord
                        P2(polar P1 0 (* SCL 0.1 DIR))
                        P3(polar P2 (/ PI 2)(/ BRKL 2))
                        P4(polar P3 0 (* SCL 0.1 DIR))
                        P5(polar P3 (/ PI 2)(/ BRKL 2))
                        P6(polar P5 PI (* SCL 0.1 DIR))
                        TP1(list(+(car P4)(* SCL 0.15 DIR))(-(cadr P4)(/ THGT 2)))
                     )
                     (if (/= BRK1 BRK2)
                        (command "pline" P1 P2 P3 P4 P3 P5 P6 ""
                           "fillet" "p" "l"
                        )
                     )
                     ;BRACKET TEXT
                     (setq BT nil)
                     (while (/= BT "")
                        (setq TP2(polar TP1 0 (* SCL 2.0 DIR))
                           TP3(polar TP2 (/ PI 2) THGT)
                           TP4(polar TP1 (/ PI 2) THGT)
                        )
                        (grdraw TP1 TP2 2 -1)
                        (grdraw TP2 TP3 2 -1)
                        (grdraw TP3 TP4 2 -1)
                        (grdraw TP4 TP1 2 -1)
                        (setq BT(strcase(getstring T "\nBracket text or ENTER to quit: ")))        
                        (grdraw TP1 TP2 0)
                        (grdraw TP2 TP3 0)
                        (grdraw TP3 TP4 0)
                        (grdraw TP4 TP1 0)
                        (if (= DIR -1)
                           (command "text" "r" TP1 "" BT)
                           (command "text" TP1 "" BT)
                        )
                        (setq TP1(list(car TP1)(-(cadr TP1)(* THGT 1.666))))
                     )                                     
                  )
               )
            )
         )
      )   
   )      
   (command "layer" "s" LA1 "")
   (setvar "blipmode" 1)
   (setvar "regenmode" 1)
   (setvar "cmdecho" 1)
)
(princ); end ldrm.lsp

